summaryrefslogtreecommitdiff
path: root/booksplit
diff options
context:
space:
mode:
Diffstat (limited to 'booksplit')
-rwxr-xr-xbooksplit52
1 files changed, 52 insertions, 0 deletions
diff --git a/booksplit b/booksplit
new file mode 100755
index 0000000..14187ab
--- /dev/null
+++ b/booksplit
@@ -0,0 +1,52 @@
+#!/bin/sh
+#==================================
+# Copyright Luke Smith
+# This notice by Zachary Smith (unrelated)
+# booksplit is designed to split audiobooks into chapters
+# it can also be used to split whole albums into songs
+#==================================
+
+# Requires ffmpeg (audio splitting) and my `tag` wrapper script.
+
+[ ! -f "$2" ] && printf "The first file should be the audio, the second should be the timecodes.\\n" && exit
+
+echo "Enter the album/book title:"; read -r booktitle
+
+echo "Enter the artist/author:"; read -r author
+
+echo "Enter the publication year:"; read -r year
+
+inputaudio="$1"
+
+# Get a safe file name from the book.
+escbook="$(echo "$booktitle" | iconv -cf UTF-8 -t ASCII//TRANSLIT | tr -d '[:punct:]' | tr '[:upper:]' '[:lower:]' | tr ' ' '-' | sed "s/-\+/-/g;s/\(^-\|-\$\)//g")"
+
+! mkdir -p "$escbook" && echo "Do you have write access in this directory?" && exit 1
+
+# As long as the extension is in the tag script, it'll work.
+ext="mp3"
+#ext="${1#*.}"
+
+# Get the total number of tracks from the number of lines.
+total="$(wc -l < "$2")"
+
+while read -r x;
+do
+ end="$(echo "$x" | cut -d' ' -f1)"
+
+ [ -n "$start" ] &&
+ echo "From $start to $end; $track $title"
+ file="$escbook/$(printf "%.2d" "$track")-$esctitle.$ext"
+ [ -n "$start" ] && echo "Splitting \"$title\"..." &&
+ ffmpeg -nostdin -y -loglevel -8 -i "$inputaudio" -ss "$start" -to "$end" -vn -acodec mp3 "$file" &&
+ echo "Tagging \"$title\"..." && mid3v2 -a "$author" -A "$booktitle" -t "$title" -T "$track" -y "$year" "$file"
+ title="$(echo "$x" | cut -d' ' -f 2-)"
+ esctitle="$(echo "$title" | iconv -cf UTF-8 -t ASCII//TRANSLIT | tr -d '[:punct:]' | tr '[:upper:]' '[:lower:]' | tr ' ' '-' | sed "s/-\+/-/g;s/\(^-\|-\$\)//g")"
+ track="$((track+1))"
+ start="$end"
+done < "$2"
+# The last track must be done outside the loop.
+echo "From $start to the end: $title"
+file="$escbook/$(printf "%.2d" "$track")-$esctitle.$ext"
+echo "Splitting \"$title\"..." && ffmpeg -nostdin -y -loglevel -8 -i "$inputaudio" -ss "$start" -vn -acodec mp3 "$file" &&
+ echo "Tagging \"$title\"..." && mid3v2 -a "$author" -A "$booktitle" -t "$title" -T "$track" -y "$year" "$file"